-- RenderVehicleFillStates.lua by rafftnix
-- author: rafftnix
-- date: 04.06.2012
-- History:
--          v1.0: initial Version (June 2012)
-- nderungen am Skript nur mit meiner Zustimmung!
-- Modification only with my permission


print("RenderVehicleFillStates 1.0 by rafftnix loaded");
RenderVehicleFillStates = {};
RenderVehicleFillStates.modDir = g_currentModDirectory; 

function RenderVehicleFillStates:loadMap(name)
	if self.firstLoadRunDone == nil then
		self.firstLoadRunDone = true;
		self.renderFillInfos = false;
		self.printFillInfos = false;
		self.overlay = createImageOverlay(RenderVehicleFillStates.modDir.."overlay.dds");
	end;
end;
		
function RenderVehicleFillStates:deleteMap()
end;

function RenderVehicleFillStates:mouseEvent(posX, posY, isDown, isUp, button)

end;

function RenderVehicleFillStates:keyEvent(unicode, sym, modifier, isDown)
end;

function RenderVehicleFillStates:update(dt)
	-- render
	if InputBinding.isPressed(InputBinding.RenderVehicleFillStates1) and InputBinding.isPressed(InputBinding.RenderVehicleFillStates2) and InputBinding.hasEvent(InputBinding.RenderVehicleFillStates3) then
		self.renderFillInfos = not self.renderFillInfos;
	end;
	
	-- HUD
	if InputBinding.isPressed(InputBinding.RenderVehicleFillStates1) and InputBinding.isPressed(InputBinding.RenderVehicleFillStates2) and InputBinding.hasEvent(InputBinding.RenderVehicleFillStates4) then
		self.printFillInfos = not self.printFillInfos;
	end;
end;

function RenderVehicleFillStates:draw()
	if self.printFillInfos or self.renderFillInfos then
		local textY = 0.880;
		local textX = 0.725;
		local renderMoreHUDS = false;
		local x, y, z = 0, 0, 0;
		if g_currentMission.controlledVehicle == nil then
			x, y, z = getWorldTranslation(g_currentMission.player.rootNode);
		else
			x, y, z = getWorldTranslation(g_currentMission.controlledVehicle.cameras[g_currentMission.controlledVehicle.camIndex].cameraNode);
		end;
		local maxDist = 60;
		for a=1, table.getn(g_currentMission.vehicles) do
			local vehicle = g_currentMission.vehicles[a];
			
			if vehicle.setupFromCrossroads == nil then
				-- show infos at HUD
				if self.printFillInfos then
					if vehicle.modName ~= nil then
						if vehicle.fillLevel ~= nil and vehicle.capacity ~= nil and vehicle.currentFillType ~= nil then
							local percent = tostring(math.floor(vehicle.fillLevel / vehicle.capacity * 100));
							local percentStr = " ("..percent.."%)";
							local fillType = "";
							if vehicle.currentFillType ~= Fillable.FILLTYPE_UNKNOWN then
								fillType = "l "..self:getHasText(Fillable.fillTypeIntToName[vehicle.currentFillType]).." ";
							end;
							textY = textY - 0.021;
							renderText(textX, textY, 0.02, vehicle.modName..": "..tostring(math.floor(vehicle.fillLevel))..fillType..percentStr);
						end;
						if vehicle.currentGrainTankFruitType ~= nil and vehicle.grainTankFillLevel ~= nil and vehicle.grainTankCapacity > 0 and vehicle.grainTankCapacity ~= nil then
							local percent = math.floor(vehicle.grainTankFillLevel / vehicle.grainTankCapacity * 100);
							local percentStr = " ("..tostring(percent).."%)";
							local fruitType = "";
							if vehicle.currentGrainTankFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
								local fruit = FruitUtil.fruitIndexToDesc[vehicle.currentGrainTankFruitType].name;
								fruitType = "l "..self:getHasText(fruit);
							end;
							textY = textY - 0.021;
							renderText(textX, textY, 0.02, vehicle.modName..": "..tostring(math.floor(vehicle.grainTankFillLevel))..fruitType..percentStr);
						end;
					end;
					if textY < 0.166 then
						renderOverlay(self.overlay, textX, textY, 0.275, (0.850 - textY + 0.03));
						textX = textX - 0.275;
						textY = 0.880;
					end;
				end;
				
				-- render infos over vehicle
				if self.renderFillInfos then
					local vx, vy, vz = getWorldTranslation(vehicle.components[1].node);
					local dist = Utils.vector2Length(vx-x, vz-z);
					if dist < maxDist then
						if vehicle.nicknameRenderNodeOffset ~= nil and vehicle.nicknameRenderNode ~= nil then
							local xn, yn, zn = getWorldTranslation(vehicle.nicknameRenderNode);
							projectX = xn + vehicle.nicknameRenderNodeOffset[1];
							projectY = yn + vehicle.nicknameRenderNodeOffset[2];
							projectZ = zn + vehicle.nicknameRenderNodeOffset[3];
						else
							projectX, projectY, projectZ = vx, vy + 4.5, vz;
						end;
						local sx, sy, sz = project(projectX, projectY, projectZ);
						if sz <= 1 then
							setTextAlignment(RenderText.ALIGN_CENTER);
							setTextBold(false);
							setTextColor(0.5, 1.0, 0.5, 1.0);
							-- fillables
							if vehicle.fillLevel ~= nil and vehicle.capacity ~= nil and vehicle.currentFillType ~= nil then
								sy = sy + 0.025;
								local percent = tostring(math.floor(vehicle.fillLevel / vehicle.capacity * 100));
								local percentStr = " ("..percent.."%)";
								local fillType = "";
								if vehicle.currentFillType ~= Fillable.FILLTYPE_UNKNOWN then
									fillType = "l "..self:getHasText(Fillable.fillTypeIntToName[vehicle.currentFillType]).." ";
								end;
								renderText(sx, sy-0.0015, 0.02, tostring(math.floor(vehicle.fillLevel))..fillType..percentStr);
							end;
							
							-- combines
							if vehicle.currentGrainTankFruitType ~= nil and vehicle.grainTankFillLevel ~= nil and vehicle.grainTankCapacity > 0 and vehicle.grainTankCapacity ~= nil then
								sy = sy + 0.050;
								local percent = math.floor(vehicle.grainTankFillLevel / vehicle.grainTankCapacity * 100);
								local percentStr = " ("..tostring(percent).."%)";
								local fruitType = "";
								if vehicle.currentGrainTankFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
									local fruit = FruitUtil.fruitIndexToDesc[vehicle.currentGrainTankFruitType].name;
									fruitType = "l "..self:getHasText(fruit);
								end;
								renderText(sx, sy-0.0015, 0.02, tostring(math.floor(vehicle.grainTankFillLevel))..fruitType..percentStr);
							end;
							setTextAlignment(RenderText.ALIGN_LEFT);
							setTextColor(1, 1, 1, 1.0);
						end;
					end;			
				end;
			end;
		end;
		renderOverlay(self.overlay, textX, textY, 0.275, (0.850 - textY + 0.03));
	end;
end;

function RenderVehicleFillStates:getHasText(name)
	local text = g_i18n:getText(name);
	if text ~= nil and text ~= "Missing " .. name .. " in l10n_de.xml" then
		return text;
	else
		return name;
	end;
end;

addModEventListener(RenderVehicleFillStates);